#!/usr/bin/php -q
<?php

# deactivate http headers
$no_http_headers = true;
# include some cacti files for ease of use

$pth = str_replace("/scripts","",dirname(__FILE__));

if (file_exists("$pth/include/global.php"))
    include("$pth/include/global.php");
else
    include("$pth/include/config.php");

include("$pth/lib/snmp.php");

# define all OIDs we need for further processing
$oids = array(
	"PlyMonId"			=> ".1.3.6.1.4.1.3224.10.2.1.1",
	"PlyName"			=> ".1.3.6.1.4.1.3224.10.1.1.24",
	"PlyMonPPS"			=> ".1.3.6.1.4.1.3224.10.2.1.3",
	"PlyMonPPM"			=> ".1.3.6.1.4.1.3224.10.2.1.4",
	"PlyMonTotPac"		=> ".1.3.6.1.4.1.3224.10.2.1.5",
	"PlyMonBPS"			=> ".1.3.6.1.4.1.3224.10.2.1.6",
	"PlyMonBPM"			=> ".1.3.6.1.4.1.3224.10.2.1.7",
	"PlyMonTotByte"	=> ".1.3.6.1.4.1.3224.10.2.1.8",
	"PlyMonSPS"			=> ".1.3.6.1.4.1.3224.10.2.1.9",
	"PlyMonSPM"			=> ".1.3.6.1.4.1.3224.10.2.1.10",
	"PlyMonTotSes"		=> ".1.3.6.1.4.1.3224.10.2.1.11",
	);
$xml_delimiter          =  ":";

# all required input parms
$hostname       = $_SERVER["argv"][1];
$snmp_community = $_SERVER["argv"][2];
$snmp_version   = $_SERVER["argv"][3];
$snmp_port      = $_SERVER["argv"][4];
$snmp_timeout   = $_SERVER["argv"][5];
$snmp_user      = $_SERVER["argv"][6];
$snmp_pw        = $_SERVER["argv"][7];
$cmd            = $_SERVER["argv"][8];
if (isset($_SERVER["argv"][9]))  { $query_field = $_SERVER["argv"][9]; };
if (isset($_SERVER["argv"][10])) { $query_index = $_SERVER["argv"][10]; };

# get number of snmp retries from global settings
$snmp_retries   = read_config_option("snmp_retries");

# -------------------------------------------------------------------------
# main code starts here
#
# snmp walk will not be provided with snmp_user and snmp_password
# so this will not work for SNMP V3 hosts
# -------------------------------------------------------------------------


# -------------------------------------------------------------------------
# script MUST respond to index queries
#       the command for this is defined within the XML file as
#       <arg_index>index</arg_index>
#       you may replace the string "index" both in the XML and here
# -------------------------------------------------------------------------
#       php -q <script> <parms> index
# will list all indices of the target values
# e.g. in case of interfaces
#      it has to respond with the list of interface indices
# -------------------------------------------------------------------------
if ($cmd == "index") {
        # retrieve all indices from target
        $return_arr = reindex(cacti_snmp_walk($hostname, $snmp_community, $oids["PlyMonId"],
                                              $snmp_version, $snmp_user, $snmp_pw, 
						     "", "", "", "",
						     $snmp_port, $snmp_timeout, $snmp_retries, 0));

        # and print each index as a separate line
        for ($i=0;($i<sizeof($return_arr));$i++) {
                print $return_arr[$i] . "\n";
        }

# -------------------------------------------------------------------------
# script MUST respond to query requests
#       the command for this is defined within the XML file as
#       <arg_query>query</arg_query>
#       you may replace the string "query" both in the XML and here
# -------------------------------------------------------------------------
#       php -q <script> <parms> query <function>
# where <function> is a parameter that tells this script,
# which target value should be retrieved
# e.g. in case of interfaces, <function> = ifdescription
#      it has to respond with the list of
#      interface indices along with the description of the interface
# -------------------------------------------------------------------------
}elseif ($cmd == "query") {
        $arr_index = reindex(cacti_snmp_walk($hostname, $snmp_community, $oids["PlyMonId"],
                                             $snmp_version, $snmp_user, $snmp_pw, 
						    "", "", "", "",	
						    $snmp_port, $snmp_timeout, $snmp_retries, 0));

        $arr = reindex(cacti_snmp_walk($hostname, $snmp_community, $oids[$query_field],
                                        $snmp_version, $snmp_user, $snmp_pw, 
					      "", "", "", "",	
					      $snmp_port, $snmp_timeout, $snmp_retries, 0));

        for ($i=0;($i<sizeof($arr_index));$i++) {
                print $arr_index[$i] . $xml_delimiter . $arr[$i] . "\n";
        }
# 
# -------------------------------------------------------------------------
# script MUST respond to get requests
#       the command for this is defined within the XML file as
#       <arg_get>get</arg_get>
#       you may replace the string "get" both in the XML and here
# -------------------------------------------------------------------------
#       php -q <script> <parms> get <function> <index>
# where <function> is a parameter that tells this script,
# which target value should be retrieved
# and   <index>    is the index that should be queried
# e.g. in case of interfaces, <function> = ifdescription
#                             <index>    = 1
#      it has to respond with
#      the description of the interface for interface #1
# -------------------------------------------------------------------------
}elseif ($cmd == "get") {
        print (cacti_snmp_get($hostname, $snmp_community, $oids[$query_field] .
                              ".$query_index" . ".0", $snmp_version, $snmp_user,
	    		         "", "", "", "",	
				  $snmp_pw, $snmp_port, $snmp_timeout, $snmp_retries, 0));

# -------------------------------------------------------------------------
} else {
        print "Invalid use of script query, required parameters:\n\n";
        print "    <hostname> <cmd>\n";
}

function reindex($arr) {
        $return_arr = array();

        for ($i=0;($i<sizeof($arr));$i++) {
                $return_arr[$i] = $arr[$i]["value"];
        }

        return $return_arr;
}

?>
